//
// Syndication.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Syndication: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var memberId: Int?
    public var officeId: Int?
    public var publisherId: Int?
    public var permission: String?
    public var createdAt: Date?
    public var updatedAt: Date?
    public var member: Member?
    public var office: Office?
    public var publisher: Publisher?

    public init(id: Int? = nil, memberId: Int? = nil, officeId: Int? = nil, publisherId: Int? = nil, permission: String? = nil, createdAt: Date? = nil, updatedAt: Date? = nil, member: Member? = nil, office: Office? = nil, publisher: Publisher? = nil) {
        self.id = id
        self.memberId = memberId
        self.officeId = officeId
        self.publisherId = publisherId
        self.permission = permission
        self.createdAt = createdAt
        self.updatedAt = updatedAt
        self.member = member
        self.office = office
        self.publisher = publisher
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case memberId
        case officeId
        case publisherId
        case permission
        case createdAt
        case updatedAt
        case member = "Member"
        case office = "Office"
        case publisher = "Publisher"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(memberId, forKey: .memberId)
        try container.encodeIfPresent(officeId, forKey: .officeId)
        try container.encodeIfPresent(publisherId, forKey: .publisherId)
        try container.encodeIfPresent(permission, forKey: .permission)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(member, forKey: .member)
        try container.encodeIfPresent(office, forKey: .office)
        try container.encodeIfPresent(publisher, forKey: .publisher)
    }
}

